from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util
from Property import Property

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('com.ibm.etools.webservice.wscommonext.TrustMethod')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSpherecom.ibm.etools.webservice.wscommonext.TrustMethod");
  exportedObject.put("roleName", "WebSpherecom.ibm.etools.webservice.wscommonext.TrustMethod");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.com.ibm.etools.webservice.wscommonext.trustmethod.localname", objid, "localName","com.ibm.etools.webservice.wscommonext.TrustMethod");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.com.ibm.etools.webservice.wscommonext.trustmethod.part", objid, "part","com.ibm.etools.webservice.wscommonext.TrustMethod");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.com.ibm.etools.webservice.wscommonext.trustmethod.name", objid, "name","com.ibm.etools.webservice.wscommonext.TrustMethod");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.com.ibm.etools.webservice.wscommonext.trustmethod.uri", objid, "uri","com.ibm.etools.webservice.wscommonext.TrustMethod");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  typeFolders = {};
  extraObjects = Property.exportProperties(objid, respath, extraObjects, typeFolders, 'properties',"com.ibm.etools.webservice.wscommonext.TrustMethod");
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('com.ibm.etools.webservice.wscommonext.TrustMethod');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('com.ibm.etools.webservice.wscommonext.TrustMethod')
  if not jsonobject.has("roleProperties"):
    raise Exception("com.ibm.etools.webservice.wscommonext.TrustMethod resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "localName", roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.localname", None));
  Util.addIfNotNone(properties, "part", roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.part", None));
  Util.addIfNotNone(properties, "name", roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.name", None));
  Util.addIfNotNone(properties, "uri", roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.uri", None));
  print "Creating com.ibm.etools.webservice.wscommonext.TrustMethod with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("com.ibm.etools.webservice.wscommonext.TrustMethod", parentid, properties);
  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString('roleName');
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('com.ibm.etools.webservice.wscommonext.TrustMethod');

def update(objid,jsonobject):
  Util.pushPathElement('com.ibm.etools.webservice.wscommonext.TrustMethod')
  if not jsonobject.has("roleProperties"):
    raise Exception("com.ibm.etools.webservice.wscommonext.TrustMethod resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.localname", None), "localName","com.ibm.etools.webservice.wscommonext.TrustMethod");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.part", None), "part","com.ibm.etools.webservice.wscommonext.TrustMethod");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.name", None), "name","com.ibm.etools.webservice.wscommonext.TrustMethod");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.com.ibm.etools.webservice.wscommonext.trustmethod.uri", None), "uri","com.ibm.etools.webservice.wscommonext.TrustMethod");
  if len(atts) != 0:
    print "Modifying com.ibm.etools.webservice.wscommonext.TrustMethod with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "com.ibm.etools.webservice.wscommonext.TrustMethod configuration up to date.";

  Property.removeProperties(objid, 'properties',"com.ibm.etools.webservice.wscommonext.TrustMethod");

  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString('roleName');
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('com.ibm.etools.webservice.wscommonext.TrustMethod');
